#coding: utf8 

# Create your views here.
from django.db.models import Q
from django.shortcuts import render_to_response
from models import Libentry, TagsEn, TagsEl
from forms import EntryForm, EditForm
from django.template import Context
from django.template.loader import get_template
from django.http import HttpResponse
from django.http import HttpResponseRedirect
from random import randrange


class TagCloud:
	def __init__(self, tagdesc,tagsize):
		self.tagdesc=tagdesc
		self.tagsize=tagsize
class AssocTag:
	def __init__(self,tagdesc):
		self.tagdesc=tagdesc


def maketaglist(tags):
	taglist=[]
	start=0
	plt=tags.find('<',start)
	while plt>-1:
		pgt=tags.find('>',start)
		s=tags[plt+1:pgt]
		taglist.append(s)
		start=pgt+1
		plt=tags.find('<',start)
	return taglist		
	

def updatetagsen(taglistpar):
	for str in taglistpar:                
		try:
		    t=TagsEn.objects.get(tagdesc=str)
		except TagsEn.DoesNotExist:		    
		    t1=TagsEn(tagdesc=str)
		    t1.save()  			    
		    print t1.tagdesc
                else:
		    print 'found\n'
		    

def updatetagsel(taglistpar):
	for str in taglistpar:		
		try:
		    t=TagsEl.objects.get(tagdesc=str)
		except TagsEl.DoesNotExist:
		    t1=TagsEl(tagdesc=str)
		    t1.save()
		    print t1.tagdesc
		else:
		    print 'found\n'
		

def checkifurlexists(urlcheck):
	nofitems=Libentry.objects.filter(urladd=urlcheck).count()
	return nofitems	

def get15randomrecs(activetag,sel_lang):
	rand15recs=[]
        selnumbers=""
        countsel=0
	if activetag=="":		
		libentries=Libentry.objects.filter(lang=sel_lang)
	else:
		libentries=Libentry.objects.filter(lang=sel_lang).filter(tags__contains="<"+activetag+">")

	nofitems=len(libentries)/2
        if nofitems>0:			
		while countsel<20:	
			rn=randrange(1,nofitems)
			strrn=str(rn)
			plt=selnumbers.find(strrn)
		        
			if plt==-1:
				rand15recs.append(libentries[rn])
				selnumbers+=","+strrn
			countsel=countsel+1
	return rand15recs

def preparetagcloud(taglist,thislang):
	tagcomposite=[]
	maxentries=0
	for itag in taglist:				
		nofarticles=Libentry.objects.filter(lang=thislang).filter(tags__contains="<"+itag.tagdesc+">").count()
		if maxentries<nofarticles:
			maxentries=nofarticles
		tagcomposite.append(TagCloud(itag.tagdesc,nofarticles))                 
	sizestep=maxentries/3	
	if sizestep<1:
		sizestep=1
	count=0
	while count<len(tagcomposite):
		tsize=tagcomposite[count].tagsize/sizestep
		tagcomposite[count].tagsize=tsize
		count=count+1
		
	return tagcomposite
		
def findassoctags(libentry_list,tagselected):
	entrytaglist=[]
	assoctaglist=[]
	for libe in libentry_list:
		entrytaglist=maketaglist(libe.tags)
		for etlist in entrytaglist:			
			if etlist!=tagselected:
				if findinassoctag(assoctaglist,etlist):				
					a=10
				else:
					assoctaglist.append(AssocTag(etlist))
	assoctaglist=sorttagobjects(assoctaglist)
	return assoctaglist

def sorttagobjects(lista):	
	for i in range ( 0, len ( lista ) - 1 ):
		for j in range ( i+1, len ( lista )):	
			if lista[i].tagdesc > lista[j].tagdesc :			
				lista[j], lista[i] = lista[i], lista[j] # swap
			
	return lista

def findinassoctag(assoctag,text):
	found=False
	for atag in assoctag:
		if atag.tagdesc==text:
			found=True
			break
	return found
	
	
def libentry(request):
	if request.method == 'POST':
		form=EntryForm(request.POST)
		if checkifurlexists(request.POST['url'])>0:
			err=True
			return render_to_response('libentry.html',{'form':form,'error':err})
		if form.is_valid():
			tagenlist=[]
			p1=Libentry(title=request.POST['titleen'],tags=request.POST['tagsen'], lang='en',
                	abstract=request.POST['abstracten'], urladd=request.POST['url'])
                	p1.save()
			tagenlist=maketaglist(request.POST['tagsen'])                        
			updatetagsen(tagenlist)
			tagellist=[]
                	p2=Libentry(title=request.POST['titleel'], tags=request.POST['tagsel'], lang='el',
                	abstract=request.POST['abstractel'], urladd=request.POST['url'])
                	p2.save()
			tagellist=maketaglist(request.POST['tagsel'])	
			updatetagsel(tagellist)
			return HttpResponseRedirect('../insertdata/')						
                        		
	else:
		form=EntryForm()		
		return render_to_response('libentry.html',{'form':form})

def libview(request):
	lcount=Libentry.objects.count()
	l_list=Libentry.objects.order_by("-id")[:200]
	t=get_template('libview.html')
	c=Context({'Libentry_List':l_list, 'RecCount':lcount})
	html= t.render(c)
	return HttpResponse(html)

def libedit(request,entryid):
	l_entry=Libentry.objects.get(id=entryid)	
	if request.method == 'POST':
		form=EditForm(request.POST)
		if form.is_valid():
			taglist=[]
                        # FIXME: Use form.clean_data to access the valid data.
			l_entry.title=request.POST['title']
			l_entry.tags=request.POST['tags']
			l_entry.abstract=request.POST['abstract']
			l_entry.urladd=request.POST['url']		
			l_entry.save()
			taglist=maketaglist(request.POST['tags'])
			if l_entry.lang=='en':
				updatetagsen(taglist)
			else:
				updatetagsel(taglist)
							
			return HttpResponseRedirect('../../viewdata/')
			
	else:		
		form=EditForm(
		initial={'title':l_entry.title, 'tags':l_entry.tags, 'abstract':l_entry.abstract, 'url':l_entry.urladd}
		)
		return render_to_response('libedit.html',{'form':form})     

def firstpage(request):	
	langeng=True
	if "django_language" in request.session:		
		if request.session["django_language"]=="el":
			langeng=False
			sellang="el"
	request.session["activetag"] = ""
	taglist=[]	
	nofitems=Libentry.objects.count()
	nofitems=nofitems/2
	if langeng:
		letters=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
		sellang="en"
	else:
		letters=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","α","β","γ","δ","ε","ζ","η","θ","ι","κ","λ","μ","ν","ξ","ο","π","ρ","σ","τ","υ","φ","χ","ψ","ω"]	
		sellang="el"
	ttop=get_template('firstpagetop.html')	
	tmiddle=get_template('firstpagemiddle.html')
	tbottom=get_template('firstpagebottom.html')
	c=Context({'nofentries':nofitems, 'Letter_List':letters,'LangEng':langeng, 'Last15':True})
	html=ttop.render(c)	
	libentries=Libentry.objects.filter(lang=sellang).order_by("-id")[:15]
	for lentry in libentries:
		taglist=maketaglist(lentry.tags)		
		c=Context({'urladd':lentry.urladd, 'title':lentry.title, 'abstract':lentry.abstract, 'Itags_List':taglist})
		html+=tmiddle.render(c)
	c=Context({'nbsp':'nbsp'})
	html+=tbottom.render(c)	
	return HttpResponse(html)

def tagentries(request,tagselected):
	showentries=False
	langeng=True
	mt15=False
	randomentries=False
	if "django_language" in request.session:		
		if request.session["django_language"]=="el":
			langeng=False
	taglist=[]
	cloud_taglist=[]
	if "activetag" in request.session:
		activetag=request.session["activetag"]	
	else:
		activetag=""
	if activetag=="":	
		acttagsel=False
	else:
		acttagsel=True
	tagcloudmessage=""
        t_list=[' ']
	nofitems=Libentry.objects.count()
	nofitems=nofitems/2
	if langeng:
		letters=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
		sellang="en"
	else:
		letters=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","α","β","γ","δ","ε","ζ","η","θ","ι","κ","λ","μ","ν","ξ","ο","π","ρ","σ","τ","υ","φ","χ","ψ","ω"]
		sellang="el"	
	ttop=get_template('entriestop.html')
	tmiddle=get_template('entriesmiddle.html')
	tbottom=get_template('entriesbottom.html')
	if (len(tagselected)==1):		
		if tagselected=="R":
			libentries=get15randomrecs(activetag,sellang)
			randomentries=True
			tagassoc=True			
			if (len(activetag)>1):
				acttagsel=True				
				t_list=findassoctags(libentries,activetag)
				cloud_taglist=preparetagcloud(t_list,sellang)
			showentries=True;
		elif tagselected=="A":
			libentries=Libentry.objects.filter(lang=sellang).filter(tags__contains="<"+activetag+">").order_by("-id")
			tagassoc=True			
			if (len(activetag)>1):
				acttagsel=True				
				t_list=findassoctags(libentries,activetag)
				cloud_taglist=preparetagcloud(t_list,sellang)
			showentries=True
		else:	
			if langeng:		
				t_list=TagsEn.objects.filter(tagdesc__startswith=tagselected).order_by("tagdesc")
			else:
				t_list=TagsEl.objects.filter(tagdesc__startswith=tagselected).order_by("tagdesc")
			tagassoc=False
			noft_list=len(t_list)
			if (noft_list>0):
				showentries=True
				activetag=t_list[0].tagdesc				
				acttagsel=True
				cloud_taglist=preparetagcloud(t_list,sellang)
				
			libentries=Libentry.objects.filter(lang=sellang).filter(tags__contains="<"+activetag+">").order_by("-id")
			
	else:
			activetag=tagselected			
			acttagsel=True
			tagassoc=True
			showentries=True			
			libentries=Libentry.objects.filter(lang=sellang).filter(tags__contains="<"+activetag+">").order_by("-id")
			t_list=findassoctags(libentries,tagselected)
			cloud_taglist=preparetagcloud(t_list,sellang)
			if len(libentries)>15:
				mt15=True
				libentries=Libentry.objects.filter(lang=sellang).filter(tags__contains="<"+activetag+">").order_by("-id")[:15]
			
	request.session["activetag"]=activetag # set session variable for activetag			
		
	c=Context({'nofentries':nofitems, 'Letter_List':letters, 'morethan15':mt15, 'acttag':activetag, 'Wordtag_List':cloud_taglist, 'acttagsel':acttagsel, 'TagSelected':tagselected, 'TagAssoc': tagassoc, 'LangEng':langeng, 'ShowEntries':showentries, 'RandomEntries':randomentries})
	html=ttop.render(c)
	if showentries:
		for lentry in libentries:
			taglist=maketaglist(lentry.tags)		
			c=Context({'urladd':lentry.urladd, 'title':lentry.title, 'abstract':lentry.abstract, 'Itags_List':taglist})
			html+=tmiddle.render(c)
	c=Context({'nbsp':'nbsp'})
	html+=tbottom.render(c)	
	return HttpResponse(html)

def about(request):
	langeng=True
	if "django_language" in request.session:		
		if request.session["django_language"]=="el":
			langeng=False
	t=get_template('about.html')
	c=Context({'LangEng':langeng})
	html= t.render(c)
	return HttpResponse(html)

def librec(request,recid):
	langeng=True
	if "django_language" in request.session:		
		if request.session["django_language"]=="el":
			langeng=False
			sellang="el"
	request.session["activetag"] = ""
	taglist=[]	
	nofitems=Libentry.objects.count()
	nofitems=nofitems/2
	if langeng:
		letters=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
		sellang="en"
	else:
		letters=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","α","β","γ","δ","ε","ζ","η","θ","ι","κ","λ","μ","ν","ξ","ο","π","ρ","σ","τ","υ","φ","χ","ψ","ω"]	
		sellang="el"
	ttop=get_template('firstpagetop.html')	
	tmiddle=get_template('firstpagemiddle.html')
	tbottom=get_template('firstpagebottom.html')
	c=Context({'nofentries':nofitems, 'Letter_List':letters,'LangEng':langeng, 'Last15':False})
	html=ttop.render(c)	
	libentries=Libentry.objects.filter(lang=sellang).filter(id__lte=recid).order_by("-id")[:15]
	for lentry in libentries:
		taglist=maketaglist(lentry.tags)		
		c=Context({'urladd':lentry.urladd, 'title':lentry.title, 'abstract':lentry.abstract, 'Itags_List':taglist})
		html+=tmiddle.render(c)
	c=Context({'nbsp':'nbsp'})
	html+=tbottom.render(c)	
	return HttpResponse(html)

	
